/* @(#)alias.c	1.2 1/21/94 
Copyright 2002 AOI Industries, Inc. All rights reserved.

License is granted to copy, to use, and to make and to use derivative
works for any purpose, provided that the copyright notice and this
license notice is included in all copies and any derivatives works and
in all  related documentation.  Licensor grants no other licenses expressed 
or implied and the licensee acknowleges that Licensor have no liability for 
licensee's use or for any derivative works made by licensee. 

This software is provided AS IS.

Licensor disclaim and licensee agrees that all warranties, express or
implied, including without limitation the implied warranties of
merchantability and fitness for a particular purpose.  Notwithstanding
any other provision contained herein, any liability for damages
resulting from the software or its use is expressly disclaimed,
including consequential or any other indirect damages, whether arising
in contract, tort (including negligence) or strict liability, even if
Licensor is advised of the possibility of such damages.  
*
 * Given a string, look up a phone number.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

#define ALIAS_FILE "/usr/local/lib/fax/alias.fax"
char *alias_scan(FILE * f, char *name);
extern char *sys_errlist[];

char *
fax_alias(char *name)
{
    FILE *f;
    char fname[256], *p;

    /* Check for a user file first. */
    p = getenv("HOME");
    if (p) {
	strcpy(fname, p);
	strcat(fname, "/.faxrc");
    } else {
	strcpy(fname, ".faxrc");
	puts("***Warning - no $HOME environment variable");
    }


    f = fopen(fname, "r");
    if (!f) {
	if (errno != ENOENT) {
	    perror("can't open ~/.faxrc");
	    return 0;
	}
    } else {
	p = alias_scan(f, name);
	if (p) return p;
    }

    f = fopen(ALIAS_FILE, "r");
    if (!f) {
	if (errno != ENOENT) {
	    printf("can't open %s: %s\n", ALIAS_FILE, sys_errlist[errno]);
	}
	return 0;
    } else {
	return alias_scan(f, name);
    }
}

char *
alias_scan(FILE * f, char *name)
{
    char *p, *q=0;
    static char buff[256];
    int found;

    found = 0;
    while (fgets(buff, sizeof(buff), f)) {
	p = buff;
	while (*p && isspace(*p)) p++;
    	q = p;
	while (*q && !isspace(*q)) q++;
    	*q = 0;	    	    	    /* null terminate alias name */

	if (!strcmp(p, name)) {
	    found = 1;
	    break;
	}
    }

    fclose(f);

    if (found) {
    	q++;
	while (*q && isspace(*q)) q++;    /* scan to start of phone number */
	p = q;
	while (*p && !isspace(*p)) p++;   /* null terminate phone number */
	*p = 0;

	return q;
    } else {
	return 0;
    }
}
