/* @(#)frmPeekAhead.c	1.3 3/29/92
Copyright 2002 AOI Industries, Inc. All rights reserved.

License is granted to copy, to use, and to make and to use derivative
works for any purpose, provided that the copyright notice and this
license notice is included in all copies and any derivatives works and
in all  related documentation.  Licensor grants no other licenses expressed 
or implied and the licensee acknowleges that Licensor have no liability for 
licensee's use or for any derivative works made by licensee. 

This software is provided AS IS.

Licensor disclaim and licensee agrees that all warranties, express or
implied, including without limitation the implied warranties of
merchantability and fitness for a particular purpose.  Notwithstanding
any other provision contained herein, any liability for damages
resulting from the software or its use is expressly disclaimed,
including consequential or any other indirect damages, whether arising
in contract, tort (including negligence) or strict liability, even if
Licensor is advised of the possibility of such damages.  
 */

/* frmPeekAhead()
 *
 * Return TRUE if the looked for sysmbols apppear, and appear prior
 * to the "before" sysmbols.  Otherwise return FALSE.
 */

#include <string.h>
#include "formdef.h"

int frmPeekAhead(p, lookfor, before)
    char **p;       /* current position within above form */
    char *lookfor;  /* symbols that you wish to see ... */
    char *before;   /* ... before encountering these symbols. */
{
    char *q1, *q2;
    int status;
    
    q1 = strpbrk(*p, lookfor);
    q2 = strpbrk(*p, before);

    if (!q1) 	    	    /* looked for symbols not found */
	status = FALSE;
    else if (!q2)   	    /* looked for symbols found and other ... */
	status = TRUE;	    /* ... symbols not not found */
    else if (q1 < q2)
	status = TRUE;	    /* looked for symbols found before others */
    else 
	status = FALSE;	    /* looked for symbols found after */

    if (status)     	    /* only advance pointer if the looked ... */
    	*p = q1;    	    /* ... string has been found */
	
    return(status);
}
