/* @(#)listlen.c	1.4 10/29/02 
Copyright 2002 AOI Industries, Inc. All rights reserved.

License is granted to copy, to use, and to make and to use derivative
works for any purpose, provided that the copyright notice and this
license notice is included in all copies and any derivatives works and
in all  related documentation.  Licensor grants no other licenses expressed 
or implied and the licensee acknowleges that Licensor have no liability for 
licensee's use or for any derivative works made by licensee. 

This software is provided AS IS.

Licensor disclaim and licensee agrees that all warranties, express or
implied, including without limitation the implied warranties of
merchantability and fitness for a particular purpose.  Notwithstanding
any other provision contained herein, any liability for damages
resulting from the software or its use is expressly disclaimed,
including consequential or any other indirect damages, whether arising
in contract, tort (including negligence) or strict liability, even if
Licensor is advised of the possibility of such damages.  
 */

#include "formdef.h"

#define max(x, y) ((x) > (y) ? (x):(y))

/*
 * Figure out the maximum width of a list field.
 * fp must point to first character after '['
 */

int listlen(char *fp)
{
    char *q;
    int   len, max_width;

    max_width = 0;

    q = fp;

    /* Trip along the list choices, and find the one w/ the max length */
    while (*q != ']' && *q != ')') {
        next_choice(&q, &len);
        max_width = max(max_width, len);

        /* remember next_choice leaves q @ ',' or  `]' */
        if (*q == ',') q++;
    }

    return max_width;
}
