/* @(#)reset_attr.c	1.5 9/10/91
Copyright 2002 AOI Industries, Inc. All rights reserved.

License is granted to copy, to use, and to make and to use derivative
works for any purpose, provided that the copyright notice and this
license notice is included in all copies and any derivatives works and
in all  related documentation.  Licensor grants no other licenses expressed 
or implied and the licensee acknowleges that Licensor have no liability for 
licensee's use or for any derivative works made by licensee. 

This software is provided AS IS.

Licensor disclaim and licensee agrees that all warranties, express or
implied, including without limitation the implied warranties of
merchantability and fitness for a particular purpose.  Notwithstanding
any other provision contained herein, any liability for damages
resulting from the software or its use is expressly disclaimed,
including consequential or any other indirect damages, whether arising
in contract, tort (including negligence) or strict liability, even if
Licensor is advised of the possibility of such damages.  
 */
/* This routine is called when an attribute is being turned off.  We send
   the sequence to turn off all attributes, and then turn the ones we still
   want back on.  Apparently, most terminals don't allow per-attribute
   shutoff.
 */
#include <stdio.h>
#include "form.h"
#include "formdef.h"

void reset_attr(int smode)
{
   static int last_smode=0;

   if (smode == last_smode) return;

   /* Send the clear attribute string only if we need to turn
    * an attribute off, i.e., bits are set in 'last_smode' that
    * aren't set in 'smode'.
    */
   if ((last_smode^smode) & last_smode)
      normal_video();

   if (smode & BLINK)     blink_on();
   if (smode & BOLD)      bold_on();
   if (smode & REVERSE)   rev_on();
   if (smode & UNDERLINE) underline_on();

   last_smode = smode;
}
